diff --git a/minicargo.mk b/minicargo.mk
index 6c9962a6..9e3ee588 100644
--- a/minicargo.mk
+++ b/minicargo.mk
@@ -34,7 +34,7 @@ else
 endif
 
 LLVM_CONFIG := $(RUSTCSRC)build/bin/llvm-config
-RUSTC_TARGET ?= x86_64-unknown-linux-gnu
+RUSTC_TARGET ?= x86_64-unknown-linux-musl
 LLVM_TARGETS ?= X86;ARM;AArch64#;Mips;PowerPC;SystemZ;JSBackend;MSP430;Sparc;NVPTX
 OVERRIDE_DIR := script-overrides/$(RUSTC_CHANNEL)-$(RUSTC_VERSION)$(OVERRIDE_SUFFIX)/
 
diff --git a/run_rustc/Makefile b/run_rustc/Makefile
index e38e8181..48536d84 100644
--- a/run_rustc/Makefile
+++ b/run_rustc/Makefile
@@ -5,7 +5,7 @@ RUST_SRC := ../rustc-1.19.0-src/src/
 
 PREFIX := prefix/
 BINDIR := $(PREFIX)bin/
-LIBDIR := $(PREFIX)lib/rustlib/x86_64-unknown-linux-gnu/lib/
+LIBDIR := $(PREFIX)lib/rustlib/x86_64-unknown-linux-musl/lib/
 
 V ?= @
 
diff --git a/src/trans/target.cpp b/src/trans/target.cpp
index c1dce972..88c6a713 100644
--- a/src/trans/target.cpp
+++ b/src/trans/target.cpp
@@ -304,31 +304,31 @@ namespace
         {
             return load_spec_from_file(target_name);
         }
-        else if(target_name == "i586-linux-gnu")
+        else if(target_name == "i586-linux-musl")
         {
             return TargetSpec {
-                "unix", "linux", "gnu", {CodegenMode::Gnu11, "i586-linux-gnu", BACKEND_C_OPTS_GNU},
+                "unix", "linux", "musl", {CodegenMode::Gnu11, "i586-linux-musl", BACKEND_C_OPTS_GNU},
                 ARCH_X86
                 };
         }
-        else if(target_name == "x86_64-linux-gnu")
+        else if(target_name == "x86_64-linux-musl")
         {
             return TargetSpec {
-                "unix", "linux", "gnu", {CodegenMode::Gnu11, "x86_64-linux-gnu", BACKEND_C_OPTS_GNU},
+                "unix", "linux", "musl", {CodegenMode::Gnu11, "x86_64-gentoo-linux-musl", BACKEND_C_OPTS_GNU},
                 ARCH_X86_64
                 };
         }
-        else if(target_name == "arm-linux-gnu")
+        else if(target_name == "arm-linux-musl")
         {
             return TargetSpec {
-                "unix", "linux", "gnu", {CodegenMode::Gnu11, "arm-elf-eabi", BACKEND_C_OPTS_GNU},
+                "unix", "linux", "musl", {CodegenMode::Gnu11, "arm-elf-eabi", BACKEND_C_OPTS_GNU},
                 ARCH_ARM32
                 };
         }
-        else if(target_name == "aarch64-linux-gnu")
+        else if(target_name == "aarch64-linux-musl")
         {
             return TargetSpec {
-                "unix", "linux", "gnu", {CodegenMode::Gnu11, "aarch64-linux-gnu", BACKEND_C_OPTS_GNU},
+                "unix", "linux", "musl", {CodegenMode::Gnu11, "aarch64-linux-musl", BACKEND_C_OPTS_GNU},
                 ARCH_ARM64
                 };
         }
@@ -471,7 +471,7 @@ void Target_SetCfg(const ::std::string& target_name)
     if( g_target.m_os_name == "linux" )
     {
         Cfg_SetFlag("linux");
-        Cfg_SetValue("target_vendor", "gnu");
+        Cfg_SetValue("target_vendor", "unknown");
     }
 
     if( g_target.m_os_name == "freebsd" )
diff --git a/tools/common/target_detect.h b/tools/common/target_detect.h
index a4c44ba4..93377b2e 100644
--- a/tools/common/target_detect.h
+++ b/tools/common/target_detect.h
@@ -17,15 +17,15 @@
 // - Linux
 #elif defined(__linux__)
 # if defined(__amd64__)
-#  define DEFAULT_TARGET_NAME "x86_64-linux-gnu"
+#  define DEFAULT_TARGET_NAME "x86_64-linux-musl"
 # elif defined(__aarch64__)
-#  define DEFAULT_TARGET_NAME "aarch64-linux-gnu"
+#  define DEFAULT_TARGET_NAME "aarch64-linux-musl"
 # elif defined(__arm__)
-#  define DEFAULT_TARGET_NAME "arm-linux-gnu"
+#  define DEFAULT_TARGET_NAME "arm-linux-musl"
 # elif defined(__i386__)
-#  define DEFAULT_TARGET_NAME "i586-linux-gnu"
+#  define DEFAULT_TARGET_NAME "i586-linux-musl"
 # else
-#  warning "Unable to detect a suitable default target (linux-gnu)"
+#  warning "Unable to detect a suitable default target (linux-musl)"
 # endif
 // - MinGW
 #elif defined(__MINGW32__)
diff --git a/tools/minicargo/manifest.cpp b/tools/minicargo/manifest.cpp
index bbaa24f6..187d09cf 100644
--- a/tools/minicargo/manifest.cpp
+++ b/tools/minicargo/manifest.cpp
@@ -24,7 +24,7 @@
 # define CFG_UNIX   true
 # define CFG_WINDOWS false
 #else
-# define TARGET_NAME "x86_64-unknown-linux-gnu"
+# define TARGET_NAME "x86_64-unknown-linux-musl"
 # define CFG_UNIX   true
 # define CFG_WINDOWS false
 #endif
